groups:
- name: roles/float-infra-prometheus/templates/rules/rules_nginx.conf
  rules:
  - record: host:nginx_http_requests_total:rate5m
    expr: sum(rate(nginx_http_requests[5m])) by (host, vhost)
  - record: host:nginx_http_requests_errs:rate5m
    expr: sum(rate(nginx_http_requests{code=~"5.*"}[5m])) by (host, vhost)
  - record: host:nginx_http_requests_errs:ratio
    expr: (host:nginx_http_requests_errs:rate5m / host:nginx_http_requests_total:rate5m)
  - record: global:nginx_http_requests_total:rate5m
    expr: sum(rate(nginx_http_requests[5m])) by (vhost)
  - record: global:nginx_http_requests_200:rate5m
    expr: sum(rate(nginx_http_requests{code="200"}[5m])) by (vhost)
  - record: global:nginx_http_requests_errs:rate5m
    expr: sum(rate(nginx_http_requests{code=~"5.*"}[5m])) by (vhost)
  - record: global:nginx_http_requests_errs:ratio
    expr: (global:nginx_http_requests_errs:rate5m / global:nginx_http_requests_total:rate5m)
  - record: global:nginx_http_cached_requests:ratio
    expr: clamp_max(sum(rate(nginx_http_requests_cache[5m])) by (vhost, cache_status) / ignoring (cache_status) group_left global:nginx_http_requests_200:rate5m, 1)
  - record: host:nginx_http_cached_requests:ratio
    expr: clamp_max(sum(rate(nginx_http_requests_cache[5m])) by (host, cache_status) / ignoring (cache_status) group_left sum(rate(nginx_http_requests{code="200"}[5m])) by (host), 1)

- name: http_requests_ms_histogram
  rules:
  - record: vhost_le:nginx_http_requests_ms:rate5m
    expr: sum(rate(nginx_http_requests_ms[5m])) by (vhost, le)
  - record: vhost:nginx_http_requests_ms:50p5m
    expr: histogram_quantile(0.50, vhost_le:nginx_http_requests_ms:rate5m)
  - record: vhost:nginx_http_requests_ms:90p5m
    expr: histogram_quantile(0.90, vhost_le:nginx_http_requests_ms:rate5m)
  - record: vhost:nginx_http_requests_ms:99p5m
    expr: histogram_quantile(0.99, vhost_le:nginx_http_requests_ms:rate5m)
